<?php
/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://wpvivid.com
 * @since      0.9.1
 *
 * @package    WPvivid
 * @subpackage WPvivid/admin/partials
 */

if (!defined('WPVIVID_PLUGIN_DIR'))
{
    die;
}

global $wpvivid_pulgin;
$backuplist=WPvivid_Backuplist::get_backuplist();
$remoteslist=WPvivid_Setting::get_all_remote_options();
$select=WPvivid_Setting::get_user_history('remote_selected');
$schedule=WPvivid_Schedule::get_schedule();
$backupdir=WPvivid_Setting::get_backupdir();
$general_setting=WPvivid_Setting::get_setting(true, "");
$last_msg=WPvivid_Setting::get_last_backup_message('wpvivid_last_msg');
$out_of_date=$wpvivid_pulgin->_get_out_of_date_info();
$junk_file=$wpvivid_pulgin->_junk_files_info();
$website_info=$wpvivid_pulgin->get_website_info();
$loglist=$wpvivid_pulgin->get_log_list_ex();
$display_log_count=array(0=>"10",1=>"20",2=>"30",3=>"40",4=>"50");
$max_log_diaplay=20;
$default_remote_storage='';
foreach ($remoteslist['remote_selected'] as $value) {
    $default_remote_storage=$value;
}
$backup_task=$wpvivid_pulgin->_list_tasks(false);
$wpvivid_version=WPVIVID_PLUGIN_VERSION;

do_action('show_notice');
?>

<?php
function add_tab_general(){
    ?>
    <a href="#" id="wpvivid_tab_general" class="nav-tab wrap-nav-tab nav-tab-active" onclick="switchTabs(event,'general-page')"><?php _e('Backup & Restore', 'wpvivid'); ?></a>
    <?php
}

function add_tab_setting(){
    ?>
    <a href="#" id="wpvivid_tab_setting" class="nav-tab wrap-nav-tab" onclick="switchTabs(event,'settings-page')"><?php _e('Settings', 'wpvivid'); ?></a>
    <?php
}

function add_tab_schedule(){
    ?>
    <a href="#" id="wpvivid_tab_schedule" class="nav-tab wrap-nav-tab" onclick="switchTabs(event,'schedule-page')"><?php _e('Schedule', 'wpvivid'); ?></a>
    <?php
}

function add_tab_remote_storage(){
    ?>
    <a href="#" id="wpvivid_tab_remote_storage" class="nav-tab wrap-nav-tab" onclick="switchTabs(event,'storage-page')"><?php _e('Remote Storage', 'wpvivid'); ?></a>
    <?php
}

function add_tab_website_info(){
    ?>
    <a href="#" id="wpvivid_tab_debug" class="nav-tab wrap-nav-tab" onclick="switchTabs(event,'debug-page')"><?php _e('Website Info', 'wpvivid'); ?></a>
    <?php
}

function add_tab_log(){
    ?>
    <a href="#" id="wpvivid_tab_log" class="nav-tab wrap-nav-tab" onclick="switchTabs(event,'logs-page')"><?php _e('Logs', 'wpvivid'); ?></a>
    <?php
}

function add_tab_read_log(){
    ?>
    <a href="#" id="wpvivid_tab_read_log" class="nav-tab wrap-nav-tab delete" onclick="switchTabs(event,'log-read-page')" style="display: none;">
        <div style="margin-right: 15px;"><?php _e('Log', 'wpvivid'); ?></div>
        <div class="nav-tab-delete-img">
            <img src="<?php echo esc_url(plugins_url( 'images/delete-tab.png', __FILE__ )); ?>" style="vertical-align:middle; cursor:pointer;" onclick="wpvivid_close_tab(event, 'wpvivid_tab_read_log', 'wrap', 'wpvivid_tab_log');" />
        </div>
    </a>
    <?php
}

add_action('wpvivid_backuprestore_add_tab', 'add_tab_general', 10);
add_action('wpvivid_backuprestore_add_tab', 'add_tab_setting', 14);
add_action('wpvivid_backuprestore_add_tab', 'add_tab_schedule', 11);
add_action('wpvivid_backuprestore_add_tab', 'add_tab_remote_storage', 13);
add_action('wpvivid_backuprestore_add_tab', 'add_tab_website_info', 15);
add_action('wpvivid_backuprestore_add_tab', 'add_tab_log', 16);
add_action('wpvivid_backuprestore_add_tab', 'add_tab_read_log', 18);
?>

<div class="wrap">
<h1><?php _e('WPvivid Backup Plugin', 'wpvivid'); ?></h1>
    <div id="wpvivid_backup_notice">
        <?php
        if($schedule['enable'] == true) {
            if($schedule['backup']['remote'] === 1)
            {
                if($default_remote_storage == ''){
                    _e('<div class="notice notice-warning is-dismissible"><p>Warning: There is no default remote storage available for the scheduled backups, please set up it first.</p></div>');
                }
            }
        }
        ?>
    </div>
    <div id="wpvivid_remote_notice"></div>
</div>
<h2 class="nav-tab-wrapper">
    <?php do_action('wpvivid_backuprestore_add_tab');?>
</h2>
<div class="wrap" style="max-width:1720px;">
    <div id="poststuff">
        <div id="post-body" class="metabox-holder columns-2">
            <div id="post-body-content">
                <div class="inside" style="margin-top:0;">
                    <div id="general-page" class="wrap-tab-content wpvivid_tab_general" name="tab-backup" style="width:100%;">
                        <?php include_once WPVIVID_PLUGIN_DIR .'/admin/partials/wpvivid-backup-restore-page-display.php'; ?>
                    </div>
                    <div id="storage-page" class="wrap-tab-content wpvivid_tab_remote_storage" name="tab-storage" style="display:none;">
                        <?php include_once WPVIVID_PLUGIN_DIR .'/admin/partials/wpvivid-remote-storage-page-display.php'; ?>
                    </div>
                    <div id="settings-page" class="wrap-tab-content wpvivid_tab_setting" name="tab-setting" style="display:none;">
                        <?php include_once WPVIVID_PLUGIN_DIR .'/admin/partials/wpvivid-settings-page-display.php'; ?>
                    </div>
                    <div id="schedule-page" class="wrap-tab-content wpvivid_tab_schedule" name="tab-schedule" style="display: none;">
                        <?php include_once WPVIVID_PLUGIN_DIR .'/admin/partials/wpvivid-schedule-page-display.php'; ?>
                    </div>
                    <div id="debug-page" class="wrap-tab-content wpvivid_tab_debug" name="tab-debug" style="display:none;">
                        <?php include_once WPVIVID_PLUGIN_DIR .'/admin/partials/wpvivid-website-info-page-display.php'; ?>
                    </div>
                    <div id="logs-page" class="wrap-tab-content wpvivid_tab_log" name="tab-logs" style="display:none;">
                        <?php include_once WPVIVID_PLUGIN_DIR .'/admin/partials/wpvivid-logs-page-display.php'; ?>
                    </div>
                    <div id="log-read-page" class="wrap-tab-content wpvivid_tab_read_log" style="display:none;">
                        <?php include_once WPVIVID_PLUGIN_DIR .'/admin/partials/wpvivid-log-read-page-display.php'; ?>
                    </div>
                    <?php do_action('wpvivid_backuprestore_add_page');?>
                </div>

            </div>

            <div id="postbox-container-1" class="postbox-container">
                <div class="meta-box-sortables">
                    <div class="postbox">
                        <h2><span>Current Version: <?php _e($wpvivid_version, 'wpvivid'); ?></span></h2>
                    </div>

                    <div class="postbox">
                        <h2><span>How-to</span></h2>
                        <div class="inside">
                            <table class="widefat" cellpadding="0">
                                <tbody>
                                <tr class="alternate"><td class="row-title"><a href="https://wpvivid.com/get-started-settings.html" target="_blank">WPvivid Backup Settings</a></td></tr>
                                <tr><td class="row-title"><a href="https://wpvivid.com/get-started-create-a-manual-backup.html" target="_blank">Create a Manual Backup</a></td></tr>
                                <tr class="alternate"><td class="row-title"><a href="https://wpvivid.com/get-started-restore-site.html" target="_blank">Restore Your Site from a Backup</a></td></tr>
                                <tr><td class="row-title"><a href="https://wpvivid.com/get-started-transfer-site.html" target="_blank">Migrate WordPress</a></td></tr>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <br class="clear">
    </div>
</div>

<script>
    function switchTabs(evt,contentName) {
        // Declare all variables
        var i, tabcontent, tablinks;

        // Get all elements with class="tabcontent" and hide them
        tabcontent = document.getElementsByClassName("wrap-tab-content");
        for (i = 0; i < tabcontent.length; i++) {
            tabcontent[i].style.display = "none";
        }

        // Get all elements with class="wrap-nav-tab" and remove the class "active"
        tablinks = document.getElementsByClassName("wrap-nav-tab");
        for (i = 0; i < tablinks.length; i++) {
            tablinks[i].className = tablinks[i].className.replace(" nav-tab-active", "");
        }

        // Show the current tab, and add an "nav-tab-active" class to the button that opened the tab
        document.getElementById(contentName).style.display = "block";
        evt.currentTarget.className += " nav-tab-active";
    }
    function switchrestoreTabs(evt,contentName) {
        // Declare all variables
        var i, tabcontent, tablinks;

        // Get all elements with class="table-list-content" and hide them
        tabcontent = document.getElementsByClassName("backup-tab-content");
        for (i = 0; i < tabcontent.length; i++) {
            tabcontent[i].style.display = "none";
        }

        // Get all elements with class="table-nav-tab" and remove the class "nav-tab-active"
        tablinks = document.getElementsByClassName("backup-nav-tab");
        for (i = 0; i < tablinks.length; i++) {
            tablinks[i].className = tablinks[i].className.replace(" nav-tab-active", "");
        }

        // Show the current tab, and add an "storage-menu-active" class to the button that opened the tab
        document.getElementById(contentName).style.display = "block";
        evt.currentTarget.className += " nav-tab-active";
    }

    var wpvivid_siteurl = '<?php
        $wpvivid_siteurl = array();
        $wpvivid_siteurl=WPvivid_Admin::wpvivid_get_siteurl();
        echo esc_url($wpvivid_siteurl['home_url']);
        ?>';
    var wpvivid_plugurl =  '<?php
        echo plugins_url( '', __FILE__ );
        ?>';
    var wpvivid_log_count = '<?php
        _e(sizeof($loglist['log_list']['file']), 'wpvivid');
        ?>';
    var wpvivid_log_array = '<?php
        _e(json_encode($loglist), 'wpvivid');
        ?>';
    var wpvivid_page_request = '<?php
        $page_request = WPvivid_Admin::wpvivid_get_page_request();
        _e($page_request, 'wpvivid');
        ?>';
    var wpvivid_default_remote_storage = '<?php
        _e($default_remote_storage, 'wpvivid');
        ?>';

</script>
