<table class="widefat">
    <div style="padding: 0 0 20px 10px;">There are two ways available to send us the debug information. The first one is recommended.</div>
    <div style="padding-left: 10px;">
        <strong><?php _e('Method 1.'); ?></strong> <?php _e('If you have configured SMTP on your site, enter your email address and click the button below to send us the relevant information (website info and errors logs) when you are encountering errors. This will help us figure out what happened. Once the issue is resolved, we will inform you by your email address.', 'wpvivid'); ?>
    </div>
    <div style="padding:10px 10px 0">
        <span>WPvivid support email:</span><input type="text" id="wpvivid_support_mail" value="support@wpvivid.com" readonly />
        <span>Your email:</span><input type="text" id="wpvivid_user_mail" />
    </div>
    <div class="schedule-tab-block">
        <input class="button-primary" type="submit" value="<?php esc_attr_e( 'Send Debug Information to Us', 'wpvivid' ); ?>" onclick="wpvivid_click_send_debug_info();" />
    </div>
    <div style="clear:both;"></div>
    <div style="padding-left: 10px;">
        <strong><?php _e('Method 2.'); ?></strong> <?php _e('If you didn’t configure SMTP on your site, click the button below to download the relevant information (website info and error logs) to your PC when you are encountering some errors. Sending the files to us will help us diagnose what happened.', 'wpvivid'); ?>
    </div>
    <div class="schedule-tab-block">
        <input class="button-primary" id="wpvivid_download_website_info" type="submit" name="download-website-info" value="<?php esc_attr_e( 'Download', 'wpvivid' ); ?>" />
    </div>
    <thead class="website-info-head">
    <tr>
        <th class="row-title" style="min-width: 260px;"><?php _e( 'Website Info Key', 'wpvivid' ); ?></th>
        <th><?php _e( 'Website Info Value', 'wpvivid' ); ?></th>
    </tr>
    </thead>
    <tbody class="wpvivid-websiteinfo-list" id="wpvivid_websiteinfo_list">
    <?php
    if(!empty($website_info['data'])){
        foreach ($website_info['data'] as $key=>$value) { ?>
            <?php
            $website_value='';
            if (is_array($value)) {
                foreach ($value as $arr_value) {
                    if (empty($website_value)) {
                        $website_value = $website_value . $arr_value;
                    } else {
                        $website_value = $website_value . ', ' . $arr_value;
                    }
                }
            }
            else{
                if($value === true || $value === false){
                    if($value === true) {
                        $website_value = 'true';
                    }
                    else{
                        $website_value = 'false';
                    }
                }
                else {
                    $website_value = $value;
                }
            }
            ?>
            <tr>
                <td class="row-title tablelistcolumn"><label for="tablecell"><?php _e($key, 'wpvivid'); ?></label></td>
                <td class="tablelistcolumn"><?php _e($website_value, 'wpvivid'); ?></td>
            </tr>
        <?php }} ?>
    </tbody>
</table>
<script>
    function wpvivid_get_ini_memory_limit() {
        var ajax_data = {
            'action': 'wpvivid_get_ini_memory_limit'
        };
        wpvivid_post_request(ajax_data, function (data) {
            try {
                jQuery('#wpvivid_websiteinfo_list tr').each(function (i) {
                    jQuery(this).children('td').each(function (j) {
                        if (j == 0) {
                            if (jQuery(this).html().indexOf('memory_limit') >= 0) {
                                jQuery(this).next().html(data);
                            }
                        }
                    });
                });
            }
            catch (err) {
                setTimeout(function () {
                    wpvivid_get_ini_memory_limit();
                }, 3000);
            }
        }, function (XMLHttpRequest, textStatus, errorThrown) {
            setTimeout(function () {
                wpvivid_get_ini_memory_limit();
            }, 3000);
        });
    }
    wpvivid_get_ini_memory_limit();
</script>