<?php
add_action( 'wp_enqueue_scripts', 'news_portal_child_enqueue_styles' );
function news_portal_child_enqueue_styles() {
    $parent_style = 'parent-style'; 
 
    wp_enqueue_style( 'bootstrap-css', 'https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css');
    wp_enqueue_script( 'bootstrap-js', 'https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js', array('jquery'), '4.0.0', true);
    wp_enqueue_style( $parent_style, get_template_directory_uri() . '/style.css' );
    wp_enqueue_style( 'child-style',
        get_stylesheet_directory_uri() . '/style.css',
        array( $parent_style ),
        wp_get_theme()->get('Version')
    );
    
    /*Slider CSS and JS */
//    wp_enqueue_style( 'npchild-slider-demo-css', get_stylesheet_directory_uri() . '/css/slider/demo.css');
    wp_enqueue_style( 'npchild-slider-noscript-css', get_stylesheet_directory_uri() . '/css/slider/noscript.css');
    wp_enqueue_style( 'npchild-slider-reset-css', get_stylesheet_directory_uri() . '/css/slider/reset.css');
    wp_enqueue_style( 'npchild-slider-style-css', get_stylesheet_directory_uri() . '/css/slider/style.css');
    wp_enqueue_script( 'npchild-slider-easing-js', get_stylesheet_directory_uri() . '/js/slider/jquery.easing.1.3.js', array('jquery'));
    wp_enqueue_script( 'npchild-eislideshow-js', get_stylesheet_directory_uri() . '/js/slider/jquery.eislideshow.js', array('jquery'));
    wp_enqueue_script( 'npchild-slider-scripts-js', get_stylesheet_directory_uri() . '/js/slider/slider-scripts.js', array('jquery'));
    
    /*Theme Script */
    wp_enqueue_script( 'npchild-scripts', get_stylesheet_directory_uri() . '/js/npchild-scripts.js', array('jquery'),'4.1.2', true) ;
    
    /*Datepicker CSS and JS */
    wp_enqueue_style( 'npchild-datepicker-css', get_stylesheet_directory_uri() . '/css/jquery.datetimepicker.css');
    wp_enqueue_script( 'npchild-datepicker-js', get_stylesheet_directory_uri() . '/js/jquery.datetimepicker.full.min.js', array('jquery'));
    
}

add_action( 'admin_enqueue_scripts', 'news_portal_child_admin_enqueue_styles' );
function news_portal_child_admin_enqueue_styles(){
    wp_enqueue_style( 'npchild-fontawesome', 'https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css');
    wp_enqueue_style( 'npchild-adminstyles',  get_stylesheet_directory_uri() . '/css/admin-styles.css');
    wp_enqueue_script( 'media-upload' );
    wp_enqueue_media();
    wp_enqueue_script('npchild-adminscripts', get_stylesheet_directory_uri() . '/js/admin-scripts.js', array('jquery'));

}



//Required libraries and files
require_once(get_stylesheet_directory().'/inc/npchild-customfunctions.php');
require_once(get_stylesheet_directory().'/inc/npchild-helpers.php');
require_once(get_stylesheet_directory().'/inc/npchild-widgets.php');
require_once(get_stylesheet_directory().'/inc/npchild-metaboxes.php');
require_once(get_stylesheet_directory().'/inc/npchild-shortcodes.php');
require_once(get_stylesheet_directory().'/inc/npchild-customposts.php');
require_once(get_stylesheet_directory().'/inc/hooks/npchild-custom-hooks.php');
require_once(get_stylesheet_directory().'/inc/customizer/customizer.php');


//Check for theme updates
require_once(get_stylesheet_directory().'/lib/child-theme-updates/plugin-update-checker.php');
$npchildThemeUpdateChecker = Puc_v4_Factory::buildUpdateChecker(
	'https://offlineleadthemes.s3.amazonaws.com/updates/npchildtheme.json',
	__FILE__ //Full path to the main plugin file or functions.php.
);

?>