<?php
/**
 * NP Child Theme Customizer
 */
 
function npchild_customize_register( $wp_customize ) {
    
    $wp_customize->remove_section('theme_upsell');
    
    $wp_customize->add_section( new News_Portal_Customize_Section_Upsell(
        $wp_customize,
            'theme_upsell',
            array(
                'title'    => esc_html__( 'News Portal Pro', 'news-portal' ),
                'pro_text' => esc_html__( 'Buy Pro', 'news-portal' ),
                'pro_url'  => 'https://mysterythemes.com/?wpam_id=136',
                'priority'  => 1,
            )
        )
    );
    
    /* 
    * Adding option for Footer background color 
    * under General Settings > Colors
    */
    $wp_customize->add_setting(
        'npchild_site_footer_color',
        array(
            'default'     => '#000000',
            'transport' => 'postMessage',
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control( new WP_Customize_Color_Control(
            $wp_customize,
            'npchild_site_footer_color',
            array(
                'label'      => __( 'Footer Background Color', 'news-portal' ),
                'section'    => 'colors',
                'priority'   => 5
            )
        )
    );
}
add_action( 'customize_register', 'npchild_customize_register', 45 );