<?php

$args = array(
    'post_type' => 'npchild_video_posts',
    'posts_per_page'    => 16,
    );

$posts_array = new WP_Query($args);
$posts_per_row = $a['posts_per_row'];

$show_title = $a['show_title'];
$show_excerpt = $a['show_excerpt'];
$show_image = $a['show_image'];
$show_permalink = $a['show_permalink'];

$col = "col-sm-3";
switch($posts_per_row){
    case '3': $col = "col-sm-4"; break;
    case '4': $col = "col-sm-3"; break;
    default: $col = "col-sm-4"; break;
}
//print_r($posts_array);

//add_thickbox();

?>
<style type="text/css">
    .bottom_space{
        padding: 20px 0px;
    }
    .grid-content{
        padding:0px;
        margin:0px;
        border:1px solid #cccccc;
        min-height: 450px;
    }
    .grid-image{
        margin: 0px;
        text-align:center;
        overflow:hidden;
        height: 230px;
    }
    
    /* Stretchy Wrapper - Thank you, SO Question - 33604360 */
    div.stretchy-wrapper{
        width: 100%;
        padding-bottom: 56.25%; /* 16:9 */
        position: relative;
        background: blue;
        overflow: hidden;
    }
    div.stretchy-wrapper > div {
        position: absolute;
        top: -16.75%; bottom: 0; left: 0; right: 0;
    }
    /* Stretchy Wrapper ends */
    
    .grid-text{
        margin: 10px;
    }
    .grid-title{
        font-weight:bold;
        font-size:20px;
        text-align:center;
    }
    .show-more{
        background-color: #e7e7e7;
        display:inline-block;
        padding: 0px 5px;
        margin:0px;
        float:right;
    }
/*For modal */
.modal-dialog {
      max-width: 800px;
      margin: 30px auto;
  }
.modal-body {
  position:relative;
  padding:0px;
}
.close {
  position:absolute;
  right:-30px;
  top:0;
  z-index:999;
  font-size:2rem;
  font-weight: normal;
  color:#fff;
  opacity:1;
}
/*For modal */
/* For overlay */

/* For overlay */
</style>
<script type="text/javascript">
    jQuery(document).ready(function($) {
// Gets the video src from the data-src on each button
var $videoSrc;  
$('.video-btn').click(function() {
    $videoSrc = $(this).data( "src" );
});
console.log($videoSrc);
// when the modal is opened autoplay it  
$('#myModal').on('shown.bs.modal', function (e) {
    
// set the video src to autoplay and not to show related video. 
$("#video").attr('src',$videoSrc + "?autoplay=1&amp;modestbranding=1&amp;showinfo=0" ); 
});
// stop playing the youtube video when I close the modal
$('#myModal').on('hide.bs.modal', function (e) {
    // a poor man's stop video
    $("#video").attr('src',$videoSrc); 
});
// document ready  
});
</script>
<!-- The Modal -->
<!-- Modal -->
<div class="modal fade" id="myModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-body">
       <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>        
        <!-- 16:9 aspect ratio -->
<div class="embed-responsive embed-responsive-16by9">
  <iframe class="embed-responsive-item" src="" id="video"  allowscriptaccess="always" allow="autoplay"></iframe>
</div> 
      </div>
    </div>
  </div>
</div> 
</div>

<!-- Grid start -->
<div class="container">
    <div class="row bottom_space row-eq-height">
<?php
    $c = 0;
    if($posts_array->have_posts()){
        while($posts_array->have_posts()){
            $posts_array->the_post();
            
        $video_url = get_post_meta(get_the_ID(),'npchild_video_post_url',true);
        $video_id = get_video_id($video_url);
        $video_type = get_video_type($video_url);
        $video_thumb = "";
        $video_src = "";
        
        if($video_type == "youtube"){
            $video_src = "https://www.youtube.com/embed/".$video_id;
            $video_thumb = "https://img.youtube.com/vi/".$video_id."/hqdefault.jpg";    
        }
        if($video_type == "vimeo"){
            $hash = unserialize(file_get_contents("http://vimeo.com/api/v2/video/$video_id.php"));
            $video_thumb = $hash[0]['thumbnail_large'];
            $video_src = "//player.vimeo.com/video/".$video_id;
        }
        if($video_type == "mp4"){
            $video_src = $video_url;
        }
        if(has_post_thumbnail()){
            $video_thumb = get_the_post_thumbnail_url();
        }
        //echo $video_thumb;
?>
    <div class="<?php echo $col;?>">
        <div class="grid-content" style="padding:0">
            <div class="grid-image" style="padding:0">
                <a href="#" class="video-btn" data-toggle="modal" data-src="<?php echo $video_src;?>" data-target="#myModal">
                <div class="stretchy-wrapper">    
                    <div>
                        <img src=<?php echo $video_thumb;?> style="min-height: 230px;">
                    </div>
                </div>
                </a>
            </div>
            <div class="grid-text">
            <?php 
                if($show_title == "on"){
            ?>
                <h5 class="grid-title"><?php echo get_the_title();?></h5>
            <?php
                }
                if($show_excerpt == "on"){
            ?>
                <p class="grid-text"><?php echo wp_trim_words(get_the_content(), 25);?></p>
            <?php
                }
            ?>
                <div style="text-align:center">
                <a href="#" class="video-btn btn btn-info" data-toggle="modal" data-src="<?php echo $video_src;?>" data-target="#myModal">View Video</a>
                </div>
            </div>
        </div>
    </div>
<?php
    $c++;
    if($c == $posts_per_row){
        $c=0;
?>
    </div><div class="row bottom_space">
<?php
    }
    
   
        }
    }
    wp_reset_query();
?>
    </div>
</div>
<!-- Grid ends -->