<?php
/* Register a new sidebar */
add_action( 'widgets_init', 'news_portal_child_theme_widgets' );
function news_portal_child_theme_widgets(){
    register_sidebar( array(
        'name' => __( 'Home Page Banner Section', 'npchild' ),
        'id' => 'npchild-hpbanner-1',
        'description' => __( 'This is the widget where the call to action and opt-in can be shown.', 'npchild' ),
        'before_widget' => '',
	'after_widget'  => '',
	'before_title'  => '',
	'after_title'   => '',
    ) );
    
}

//Registering Widgets
function npchild_load_widget(){
    register_widget('npchild_header_widget');
    register_widget('npchild_vertical_double_banner_widget');
}
add_action('widgets_init', 'npchild_load_widget');

//NPChild Header Widget
class npchild_header_widget extends WP_Widget{
    function __construct(){
        parent::__construct(
            'npchild_header_widget',
            __('NPC: Header Optin', 'news-portal-child'),
            array(
                'description'   =>  __('Header Widget with space for Opt-in', 'news-portal-child'),
                )
            );
    }

    public function form($instance){
?>
<div class="npchild-widget-intro">If you do not want any of the elements below to show on your website, leave it blank.</div>
<?php
        if(isset($instance['title'])){
            $title = $instance['title'];
        }else{
            $title = __('', 'news-portal-child');
        }
?>
<p>
    <span class="field-label">
        <?php _e('Title');?>
    </span>
    <input class="widefat" id="<?php echo $this->get_field_id('title');?>" name="<?php echo $this->get_field_name('title');?>" type="text" value="<?php echo esc_attr($title);?>" />
</p>
<?php
        if(isset($instance['background_image'])){
            $background_image = $instance['background_image'];
        }else{
            $background_image = __('', 'news-portal-child');
        }
?>
<p>
    <span class="field-label">
        <?php _e('Background Image');?>
    </span>
    <div class="upload-btn-div">
   <input class="widefat" id="<?php echo $this->get_field_id( 'background_image' ); ?>" name="<?php echo $this->get_field_name( 'background_image' ); ?>" type="text" value="<?php echo esc_url( $background_image ); ?>" />
      <button class="upload_image_button button button-primary">Upload Image</button></div>
</p>
<?php
        if(isset($instance['main_heading'])){
            $main_heading = $instance['main_heading'];
        }else{
            $main_heading = __('', 'news-portal-child');
        }
?>
<p>
    <span class="field-label">
        <?php _e('Main Heading');?>
    </span>
    <input class="widefat" id="<?php echo $this->get_field_id('main_heading');?>" name="<?php echo $this->get_field_name('main_heading');?>" type"text" value="<?php echo esc_attr($main_heading);?>" />
</p>    
<?php
        if(isset($instance['sub_heading'])){
            $sub_heading = $instance['sub_heading'];
        }else{
            $sub_heading = __('', 'news-portal-child');
        }
?>
<p>
    <span class="field-label">
        <?php _e('Sub Heading');?>
    </span>
    <input class="widefat" id="<?php echo $this->get_field_id('sub_heading');?>" name="<?php echo $this->get_field_name('sub_heading');?>" type"text" value="<?php echo esc_attr($sub_heading);?>" />
</p>
<?php
    if(isset($instance['media_type'])){
        $media_type = $instance['media_type'];
    }else{
        $media_type = 'video';
    }
?>
<script type="text/javascript">
$(document).ready(function(){
    $(".media-type").on("click", function(){
        $(".toggleBox").hide();
        switch($(this).attr("href")){
            case "#imageBox": $(".imageBox").show();break;
            case "#videoBox": $(".videoBox").show();break;
            case "#sliderBox": $(".sliderBox").show();break;
            default: break;
        }
        
    }); 
});
</script>
<p>
    <span class="field-label">
        <?php _e('Media Type');?>
        <span class="tooltip">
            <i class="fa fa-question-circle" aria-hidden="true"></i>
            <span class="tooltiptext">Select the type of media you want to show (Video / Image / Slider / None). Default is Video.</span>
        </span>
    </span>
    <input type="radio" class="media-type" name="<?php echo $this->get_field_name( 'media_type' ); ?>" value="image" <?php checked('image', $media_type, "checked");?> id="<?php echo $this->get_field_id('media_type');?>" data-toggle="collapse" data-parent="accordion" href="#imageBox" >Image (Select below)<br>
    <input type="radio" class="media-type" name="<?php echo $this->get_field_name( 'media_type' ); ?>" value="video" <?php checked('video', $media_type, "checked");?> id="<?php echo $this->get_field_id('media_type');?>" data-toggle="collapse" data-parent="accordion" href="#videoBox" >Video<br>
    <input type="radio" class="media-type" name="<?php echo $this->get_field_name( 'media_type' ); ?>" value="slider" <?php checked('slider', $media_type, "checked");?> id="<?php echo $this->get_field_id('media_type');?>" data-toggle="collapse" data-parent="accordion" href="#sliderBox" >Slider<br>
    <input type="radio" class="media-type" name="<?php echo $this->get_field_name( 'media_type' ); ?>" value="none" <?php checked('none', $media_type, "checked");?> id="<?php echo $this->get_field_id('media_type');?>" href="#standardBox">None
</p>

<!-- Add upload code for image and slider shortcode section here -->

<?php
        if(isset($instance['media_image'])){
            $media_image = $instance['media_image'];
        }else{
            $media_image = __('', 'news-portal-child');
        }
     $hide_css = "";
     if($media_type !== "image")
        $hide_css = "style='display:none'";
?>
<div class="imageBox toggleBox" <?php echo $hide_css;?>>
<p>
    <span class="field-label">
        <?php _e('Image');?>
    </span>
    <div class="upload-btn-div">
   <input class="widefat" id="<?php echo $this->get_field_id( 'media_image' ); ?>" name="<?php echo $this->get_field_name( 'media_image' ); ?>" type="text" value="<?php echo esc_url( $media_image ); ?>" />
      <button class="upload_image_button button button-primary">Upload Image</button></div>
</p>
</div>
<?php
    if(isset($instance['video_url'])){
            $video_url = $instance['video_url'];
        }else{
            $video_url = __('', 'news-portal-child');
        }
    $hide_css = "";
     if($media_type !== "video")
        $hide_css = "style='display:none'";
?>
<p class="videoBox toggleBox" <?php echo $hide_css;?>>
    <span class="field-label">
        <?php _e('Video URL');?>
        <span class="tooltip">
            <i class="fa fa-question-circle" aria-hidden="true"></i>
            <span class="tooltiptext">Add your Video URL below, and select the type (Youtube / Vimeo / MP4)</span>
        </span>
    </span>
    <input class="widefat" id="<?php echo $this->get_field_id('video_url');?>" name="<?php echo $this->get_field_name('video_url');?>" type"text" value="<?php echo esc_attr($video_url);?>" />
</p>
<?php
    if(isset($instance['video_type'])){
            $video_type = $instance['video_type'];
        }else{
            $video_type = 'youtube';
        }
    $hide_css = "";
     if($media_type !== "video")
        $hide_css = "style='display:none'";
?>
<p class="videoBox toggleBox" <?php echo $hide_css;?>>
    <input type="radio" name="<?php echo $this->get_field_name( 'video_type' ); ?>" value="youtube" <?php checked('youtube', $video_type, "checked");?> id="<?php echo $this->get_field_id('video_type');?>" >YouTube
    <input type="radio" name="<?php echo $this->get_field_name( 'video_type' ); ?>" value="vimeo" <?php checked('vimeo', $video_type, "checked");?> id="<?php echo $this->get_field_id('video_type');?>" >Vimeo
    <input type="radio" name="<?php echo $this->get_field_name( 'video_type' ); ?>" value="mp4" <?php checked('mp4', $video_type, "checked");?> id="<?php echo $this->get_field_id('video_type');?>" >MP4
</p>

<!-- New slider code -->
<?php
        if(isset($instance['slider_box'])){
            $slider_box = $instance['slider_box'];
        }else{
            $slider_box = '';
        }
        $hide_css = "";
        if($media_type !== "slider")
            $hide_css = "style='display:none'";
?>
<div class="sliderBox toggleBox myBox" <?php echo $hide_css;?>>
    <span class="field-label">
        <?php _e('Slider Shortcode');?> 
        <span class="tooltip">
            <i class="fa fa-question-circle" aria-hidden="true"></i>
            <span class="tooltiptext">Use the "Slider" tab on the left to easily create a slider and get the shortcode.</span>
        </span>
    </span>
	<textarea class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'slider_box' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'slider_box' ) ); ?>"><?php echo wp_kses_post( $slider_box ); ?></textarea>
</div>
<!-- New slider code ends -->

<?php
        if(isset($instance['slider_code'])){
            $slider_code = $instance['slider_code'];
        }else{
            $slider_code = '';
        }
    $hide_css = "";
     if($media_type !== "none")
        $hide_css = "style='display:none'";
?>
<p class="standardBox toggleBox" <?php echo $hide_css;?>>
    <span class="field-label">
        <?php _e('Your Own HTML');?> 
        <span class="tooltip">
            <i class="fa fa-question-circle" aria-hidden="true"></i>
            <span class="tooltiptext">Add your HTML code here (for example, a 3rd party slider code that you want to use). You can also leave it blank if you wish.</span>
        </span>
    </span>
	<textarea class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'slider_code' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'slider_code' ) ); ?>"><?php echo wp_kses_post( $slider_code ); ?></textarea>
</p>
<hr>
<?php
        if(isset($instance['html_box'])){
            $html_box = $instance['html_box'];
        }else{
            $html_box = '';
        }
?>
    <span class="field-label">
        <?php _e('Form Shortcode');?> 
        <span class="tooltip">
            <i class="fa fa-question-circle" aria-hidden="true"></i>
            <span class="tooltiptext">Use "Settings > Shortcoder" to easily create a shortcode (for eg: your Optin code).</span>
        </span>
    </span>
	<textarea class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'html_box' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'html_box' ) ); ?>"><?php echo wp_kses_post( $html_box ); ?></textarea>
<?php

    }
    
    //Widget Frontend
    public function widget($args, $instance){
        
        if(empty($instance)){
            return;
        }
        
        $main_heading = $instance['main_heading'];
        $sub_heading = $instance['sub_heading'];
        $media_type = empty($instance['media_type'])?"video":$instance['media_type'];
        $video_url = $instance['video_url'];
        $video_type = empty($instance['video_type'])?"youtube":$instance['video_type'];
        $slider_code = !empty( $instance['slider_code'] ) ? $instance['slider_code'] : '';
        $slider_box_content = !empty( $instance['slider_box'] ) ? $instance['slider_box'] : '';        
        $html_box_content = !empty( $instance['html_box'] ) ? $instance['html_box'] : '';
        $background_image = !empty( $instance['background_image'] ) ? $instance['background_image'] : '';
        $media_image = !empty( $instance['media_image'] ) ? $instance['media_image'] : '';
        $slider_image = !empty( $instance['slider_image'] ) ? $instance['slider_image'] : '';
        $title = apply_filters('widget_title', $instance['title']);
        
        $video_css = "margin:20px 0px;text-align:center;border:5px solid #424545;border-radius:5px;box-shadow: 0 12px 6px -6px black;";
        
        ob_start();
        
        echo $args['before_widget'];
        
        if(!empty($title))
            echo $args['before_title'].$title.$args['after_title'];
        
        $bgimage_style = "background-color:#cccccc";
        
        if($background_image){
            $bgimage_style = "background: linear-gradient(0deg,rgba(225,219,219,0.7),rgba(225,219,219,0.5)), url('".esc_url($background_image)."');background-size:cover;";
        }
?>
<div class="top-header-wrap" style="<?php echo $bgimage_style;?>">
<div class="container">
    <div class="row">
        <div class="col-sm-6" style="padding-top:30px;padding-bottom:30px;">
<?php
        if(!empty($main_heading)){
?>
			<div style="line-height:48px;font-size:48px;font-weight:bold;text-align:center">     
			    <?php echo $main_heading;?>       
            </div>
<?php
        }
        if(!empty($sub_heading)){
?>
            <div style="line-height:24px;font-size:24px;font-weight:bold;text-align:center;padding:10px 0px">
				<?php echo $sub_heading;?>
			</div>
<?php
        }
        
/* Put the checks for media type here, and modify the code below to show the media accordingly */        
/* Video Display */        
        if(!empty($video_url) && ($media_type == "video")){
            $video_id = get_video_id($video_url);
            if($video_type == "youtube"){
?>
			<div class="embed-responsive embed-responsive-16by9" style="<?php echo $video_css;?>">
			<iframe class="embed-responsive-item" src="https://www.youtube.com/embed/<?php echo $video_id;?>"></iframe>
			</div>
<?php
            }
            if($video_type == "vimeo"){
?>
            <div class="embed-responsive embed-responsive-16by9" style="<?php echo $video_css;?>">
			<iframe class="embed-responsive-item" src="https://player.vimeo.com/video/<?php echo $video_id;?>"></iframe>
			</div>
<?php
            }
            if($video_type == "mp4"){
?>
            <div class="embed-responsive embed-responsive-16by9" style="<?php echo $video_css;?>">
            <video width="320" height="240" controls>
              <source src="<?php echo $video_id;?>" type="video/mp4">
            Your browser does not support the video tag.
            </video>
            </div>
<?php
            }
        }
/* Image display */
        if(!empty($media_image) && ($media_type == "image")){
?>
    <div style="<?php echo $video_css;?>">
        <img class="img-fluid" src="<?php echo $media_image;?>" alt="Get an Appointment"> 
    </div>
<?php
        }
        if(!empty($media_image) && ($media_type == "slider")){
?>
<div style="display:flex;align-items:center;justify-content:center">
            <?php
                $slider_display = do_shortcode( apply_filters( 'widget_text', empty( $instance[ 'slider_box' ] ) ? '' : $instance[ 'slider_box' ], $instance, $this ) );
            
                echo $slider_display;
                //echo wp_kses($instance['html_box'], array());
            ?>
        </div>
<?php
        }
?>
        </div>
        <div class="col-sm-6" style="display:flex;align-items:center;justify-content:center">
            <?php
                $html_text = do_shortcode( apply_filters( 'widget_text', empty( $instance[ 'html_box' ] ) ? '' : $instance[ 'html_box' ], $instance, $this ) );
            
                echo $html_text;
                //echo wp_kses($instance['html_box'], array());
            ?>
        </div>
</div><!-- row ends-->
</div><!-- container ends -->

</div><!-- top header wrap ends -->
<?php
        echo $args['after_widget'];    
    }
    //Widget Update
    public function update($new_instance, $old_instance){
        $instance = array();
        $instance['title'] = (!empty($new_instance['title']))?strip_tags($new_instance['title']):'';
        $instance['main_heading'] = (!empty($new_instance['main_heading']))?strip_tags($new_instance['main_heading']):'';
        $instance['sub_heading'] = (!empty($new_instance['sub_heading']))?strip_tags($new_instance['sub_heading']):'';
        $instance['media_type'] = (!empty($new_instance['media_type']))?strip_tags($new_instance['media_type']):'video';
        $instance['media_image'] = ( ! empty( $new_instance['media_image'] ) ) ? $new_instance['media_image'] : '';
        $instance['slider_image'] = ( ! empty( $new_instance['slider_image'] ) ) ? $new_instance['slider_image'] : '';
        $instance['video_url'] = (!empty($new_instance['video_url']))?strip_tags($new_instance['video_url']):'';
        $instance['video_type'] = (!empty($new_instance['video_type']))?strip_tags($new_instance['video_type']):'';
        $instance[ 'slider_box' ] = stripslashes(wp_filter_post_kses(addslashes( $new_instance[ 'slider_box' ]))); 
        $instance[ 'slider_code' ] = stripslashes(wp_filter_post_kses(addslashes( $new_instance[ 'slider_code' ]))); 
        $instance['background_image'] = ( ! empty( $new_instance['background_image'] ) ) ? $new_instance['background_image'] : '';
        $instance[ 'html_box' ] = stripslashes(wp_filter_post_kses(addslashes( $new_instance[ 'html_box' ]))); 
        //$instance['html_box'] = $new_instance['html_box'];
        return $instance;
    }
    
}
//Class npchild_header_widget ends

//NPChild Vertical Double Banner Widget
class npchild_vertical_double_banner_widget extends WP_Widget{

    function __construct(){
	    parent::__construct(
	        'npchild_vertical_double_banner_widget',
	        __('NPC: Vertical Banner Ads', 'news-portal-child'),
	        array(
	            'classname' => 'npchild_vertical_ads_banner',
	            'description'   =>  __('Vertical Double Banner Widget for sidebar', 'news-portal-child'),
	        )
	    );
    }//construct ends

    /**
     * Helper function that holds widget fields
     * Array is used in update and form functions
     * This function was created by referencing the parent theme 
     * and used in this widget to keep consistency.
     */
    private function npchild_widget_fields(){
	    $widget_fields = array(
	        'npchild_ads_title' =>  array(
	            'news_portal_widgets_name'  =>  'npchild_ads_title',
	            'news_portal_widgets_title' =>  __( 'Section Title', 'news-portal' ),
	            'news_portal_widgets_field_type'  =>  'text'
	        ),
	        
	        'npchild_ad1_image' =>  array(
	            'news_portal_widgets_name'  =>  'npchild_ad1_image',
	            'news_portal_widgets_title' =>  __( 'Ad 1: Select Image', 'news-portal' ),
	            'news_portal_widgets_field_type'  =>  'upload'
	        ),

	        'npchild_ad1_url' =>  array(
	            'news_portal_widgets_name'  =>  'npchild_ad1_url',
	            'news_portal_widgets_title' =>  __( 'Ad 1: Add URL', 'news-portal' ),
	            'news_portal_widgets_field_type'  =>  'text'
	        ),

	        'npchild_ad1_newtab' =>  array(
	            'news_portal_widgets_name'  =>  'npchild_ad1_newtab',
	            'news_portal_widgets_title' =>  __( 'Open in New Tab', 'news-portal' ),
	            'news_portal_widgets_field_type'  =>  'checkbox'
	        ),

	        'npchild_ad1_rel' =>  array(
	            'news_portal_widgets_name'  =>  'npchild_ad1_rel',
	            'news_portal_widgets_title' =>  __( 'Nofollow', 'news-portal' ),
	            'news_portal_widgets_field_type'  =>  'checkbox'
	        ),
	        
	        'npchild_ad2_image' =>  array(
	            'news_portal_widgets_name'  =>  'npchild_ad2_image',
	            'news_portal_widgets_title' =>  __( 'Ad 2: Select Image', 'news-portal' ),
	            'news_portal_widgets_field_type'  =>  'upload'
	        ),

	        'npchild_ad2_url' =>  array(
	            'news_portal_widgets_name'  =>  'npchild_ad2_url',
	            'news_portal_widgets_title' =>  __( 'Ad 2: Add URL', 'news-portal' ),
	            'news_portal_widgets_field_type'  =>  'text'
	        ),

	        'npchild_ad2_newtab' =>  array(
	            'news_portal_widgets_name'  =>  'npchild_ad2_newtab',
	            'news_portal_widgets_title' =>  __( 'Open in New Tab', 'news-portal' ),
	            'news_portal_widgets_field_type'  =>  'checkbox'
	        ),

	        'npchild_ad2_rel' =>  array(
	            'news_portal_widgets_name'  =>  'npchild_ad2_rel',
	            'news_portal_widgets_title' =>  __( 'Nofollow', 'news-portal' ),
	            'news_portal_widgets_field_type'  =>  'checkbox'
	        ),

	    );

	    return $widget_fields;
	}//npchild_widget_fields function ends

	/* Front end display of the widget */
	public function widget($args, $instance){
		extract($args);
		if( empty( $instance ) ) {
           return ;
        }

        $npchild_ads_title  = empty( $instance['npchild_ads_title'] ) ? '' : $instance['npchild_ads_title'];
        $npchild_ad1_image = empty( $instance['npchild_ad1_image'] ) ? '' : $instance['npchild_ad1_image'];
        $npchild_ad1_url = empty( $instance['npchild_ad1_url'] ) ? '#' : $instance['npchild_ad1_url'];
        $npchild_ad1_newtab = empty( $instance['npchild_ad1_newtab'] ) ? '_self' : '_blank';
        $npchild_ad1_rel = empty( $instance['npchild_ad1_rel'] ) ? '' : 'nofollow';
        $npchild_ad2_image = empty( $instance['npchild_ad2_image'] ) ? '' : $instance['npchild_ad2_image'];
        $npchild_ad2_url = empty( $instance['npchild_ad2_url'] ) ? '#' : $instance['npchild_ad2_url'];
        $npchild_ad2_newtab = empty( $instance['npchild_ad2_newtab'] ) ? '_self' : '_blank';
        $npchild_ad2_rel = empty( $instance['npchild_ad2_rel'] ) ? '' : 'nofollow';

        echo $before_widget;
?>
	<div class="np-ads-wrapper">
		<?php
			if(!empty($npchild_ads_title)){
				   echo $before_title . esc_html( $npchild_ads_title ) . $after_title;
			}

		?>
		<center>
		<?php
			if(!empty($npchild_ad1_image) ){
		?>
			<a href="<?php echo $npchild_ad1_url;?>" target="<?php echo $npchild_ad1_newtab;?>" rel="<?php echo $npchild_ad1_rel;?>"><img class="size-medium wp-image-515" style="padding: 2px; border: 1px solid #aaa;margin:10px 5px" src="<?php echo $npchild_ad1_image;?>" alt="" /></a>
		<?php
			}
			if(!empty($npchild_ad2_image) ){
		?>
			<a href="<?php echo $npchild_ad2_url;?>" target="<?php echo $npchild_ad2_newtab;?>" rel="<?php echo $npchild_ad2_rel;?>"><img class="size-medium wp-image-514" style="padding: 2px; border: 1px solid #aaa;margin:10px 5px" src="<?php echo $npchild_ad2_image;?>" alt="" /></a>
		<?php
			}
		?>
		</center>
	</div>
<?php
		echo $after_widget;
	}//Front end display ends
	
	public function update($new_instance, $old_instance){
		$instance = $old_instance;

        $npchild_widget_fields = $this->npchild_widget_fields();

        // Loop through fields
        foreach ( $npchild_widget_fields as $widget_field ) {

            extract( $widget_field );

            // Use helper function to get updated field values
            $instance[$news_portal_widgets_name] = news_portal_widgets_updated_field_value( $widget_field, $new_instance[$news_portal_widgets_name] );
        }

        return $instance;
	}//update function ends

	public function form( $instance ) {
        $npchild_widget_fields = $this->npchild_widget_fields();

        // Loop through fields
        foreach ( $npchild_widget_fields as $widget_field ) {

            // Make array elements available as variables
            extract( $widget_field );
            $npchild_widget_value = !empty( $instance[$news_portal_widgets_name] ) ? wp_kses_post( $instance[$news_portal_widgets_name] ) : '';
            news_portal_widgets_show_widget_field( $this, $widget_field, $npchild_widget_value );
        }
    }//widget form function ends
}//Class npchild_vertical_double_banner_widget ends

?>