jQuery(document).ready(function ($) {
 
   $(document).on("click", ".upload_image_button", function (e) {
      e.preventDefault();
      var $button = $(this);
 
      // Create the media frame.
      var file_frame = wp.media.frames.file_frame = wp.media({
         title: 'Select or upload image',
         library: { // remove these to show all
            type: 'image' // specific mime
         },
         button: {
            text: 'Select'
         },
         multiple: false  // Set to true to allow multiple files to be selected
      });
 
      // When an image is selected, run a callback.
      file_frame.on('select', function () {
         // We set multiple to false so only get one image from the uploader
 
         var attachment = file_frame.state().get('selection').first().toJSON();
         $button.siblings('input').val(attachment.url);
 
      });
      file_frame.on('close', function(){
         $button.siblings('input').trigger('change');
      });
      // Finally, open the modal
      file_frame.open();
   });
   
    $(document).on("click", ".gallery_image_button", function (e) {
        e.preventDefault();
        var $button = $(this);
        var $inputField = $button.siblings('input');
        var imgIDs = $button.siblings('input').val(); //for the list of files to be saved
        var file_frame;
        
        if ( file_frame ) {
            file_frame.open();
            return;
        }
        // Create the media frame.
        file_frame = wp.media.frames.file_frame = wp.media({
            title: 'Select or upload image',
            library: { // remove these to show all
                type: 'image' // specific mime
            },
            button: {
                text: 'Select'
            },
            multiple: true  // Set to true to allow multiple files to be selected
        });
        
        file_frame.on('open', function(){
            var selection = file_frame.state().get('selection');
            var ids_value = $button.siblings('input').val();
            ids_value = unique(ids_value.split(",")).join(",");
            if(ids_value.length > 0){
                var ids = ids_value.split(',');
                    ids.forEach(function(id){
                        attachment = wp.media.attachment(id);
                        attachment.fetch();
                        selection.add(attachment ? [attachment] : []);
                });
            }
        });
        
        file_frame.on('select', function(){
           var selection = file_frame.state().get('selection');
           imgIDs = "";
           selection.map(function(attachment){
              attachment = attachment.toJSON();
              
              if(imgIDs !== "")
                imgIDs += ","+attachment.id;
              else
                imgIDs += attachment.id;
           });
           imgIDs = unique(imgIDs.split(",")).join(",");
           $inputField.val(imgIDs);
           $('.image_list').empty();
           $('.image_list').append($inputField.val().split(",").length + " images selected.");
        });
        
        file_frame.on('close', function(){
            $inputField.trigger('change');
        });
        
        file_frame.open();    
    });
    
    function unique(list){
        var result = [];
        $.each(list, function(i,e){
            if ($.inArray(e, result) == -1) result.push(e);    
        });
        return result;
    }
    

});